#pragma once

#include <wmmintrin.h>

class AES192_SIMD
{
public:
	// AES192
	static const int Nk = 6;
	static const int Nb = 4;
	static const int Nr = 12;

public:
	typedef unsigned char BYTE;
	typedef unsigned long AESWORD;

protected:
	union W {
		__m128i w128[Nr + 1];
		AESWORD w32[Nb * (Nr + 1)];
	};
	W w;
	W dw;
	bool decrypting;

public:
	AES192_SIMD(const BYTE key[4 * Nk], bool decrypting)
		: decrypting(decrypting)
	{
		KeyExpansion(key);
	}

	void Cipher(const BYTE in[4 * Nb], BYTE out[4 * Nb]);
	void EqInvCipher(const BYTE in[4 * Nb], BYTE out[4 * Nb]);

protected:
	void KeyExpansion(const BYTE key[4 * Nk]);
};


